#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=.\TrayTip.ico
#AutoIt3Wrapper_outfile=..\Bin\TrayTip.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Comment=This program help you show traytip in system tray.
#AutoIt3Wrapper_Res_Description=Showing TrayTip
#AutoIt3Wrapper_Res_Fileversion=2.1.18.0
#AutoIt3Wrapper_Res_LegalCopyright= AlexII, Dark Blue Laboratory, 2006-2008.  alexii, Script-Coding.Info, 2008.
#AutoIt3Wrapper_Res_Language=1049
#AutoIt3Wrapper_Res_Field=ProductName|TrayTip
#AutoIt3Wrapper_Res_Field=ProductVersion|2.1.18
#AutoIt3Wrapper_Res_Field=Web-page| http://www.script-coding.info/
#AutoIt3Wrapper_Res_Field=Web-page| http://forum.script-coding.info/
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Include <Misc.au3>

AutoItSetOption("MustDeclareVars", 1)
AutoItSetOption("TrayIconDebug", 0)
AutoItSetOption("TrayIconHide", 0)

;-----------------------------------------------------------------------------------
;    
;-----------------------------------------------------------------------------------
Local Const $strUsing1 = _
	"TrayTip[.exe] <Title> <Text> <Timeout> <Icon>"							& @CRLF _
																			& @CRLF _
	& "<Title>"		& @TAB & @TAB & "-  [1-63 .];"				& @CRLF _
	& "<Text>"		& @TAB & @TAB & "-   [1-255 .];"		& @CRLF _
	& "<Timeout>"	& @TAB &        "-   [1-30 .];"		& @CRLF _
	& "<Icon>"		& @TAB & @TAB & "- <None|Info|Warning|Error>"			& @CRLF _
																			& @CRLF _
	& ": TrayTip  "" "" 5 Info"

Local Const $strUsing2 = _
	  @TAB & "<Title> : ~t, ~q, ~~;"										& @CRLF _
	& @TAB & "<Text> : ~t, ~q, ~~, ~n;"										& @CRLF _
	& ":"																& @CRLF _
	& @TAB & "~t - ;"												& @CRLF _
	& @TAB & "~q -  ;"										& @CRLF _
	& @TAB & "~n -   CrLf;"										& @CRLF _
	& @TAB & "~~ -  ~"												& @CRLF _
																			& @CRLF _
	& ": TrayTip "" ~q~q"" ""~t-~t~q~q.~n ~~ 8 ."" 10 Warning"

Local Const $HWND_BROADCAST      = 0xFFFF
Local Const $WM_SETTINGCHANGE    = 0x001A


Local $paramTitle
Local $paramText
Local $paramTimeout
Local $paramIcon

Local Const $strIconsName = "NONE INFO WARNING ERROR"
Local $arrIconsName
Local Const $strIcons = "0 1 2 3"
Local $arrIcons

Local $intIconFound
Local $intEnableBallonTips

Local $PID
Local $i

$arrIconsName	= StringSplit($strIconsName, " ")
$arrIcons		= StringSplit($strIcons, " ")
;-----------------------------------------------------------------------------------

;-----------------------------------------------------------------------------------
;  Swap			:   
;
; 				:
;	Value1				-  1
;	Value2				-  2
;
; 			: 
;-----------------------------------------------------------------------------------
Func Swap(ByRef $Value1, ByRef $Value2)
	Local $tempValue
	
	$tempValue = $Value1
	$Value1 = $Value2
	$Value2 = $tempValue
EndFunc

;-----------------------------------------------------------------------------------
;  Between		:      
;
; 				:
; 	intValue			-   
;	intLower			-   
;	intUpper			-   
;
; 			:
;						- /
;
; 				:
;	     -   1
;	   ,  
;-----------------------------------------------------------------------------------
Func Between($intValue, $intLower, $intUpper)
	If IsNumber($intValue) _
		And IsNumber($intLower) _
		And IsNumber($intUpper) Then
		
		If $intLower > $intUpper Then
			Swap($intLower, $intUpper)
		EndIf
		
		If $intValue >= $intLower And $intValue <= $intUpper Then
			Return True
		Else
			Return False
		EndIf
	Else
		SetError(1)
	EndIf
EndFunc

;-----------------------------------------------------------------------------------
;  IsInArray		:     
;
; 				:
; 	arrArray			-   
;	strValue			-     
;
; 			:
;	 		-    
;	  		- 0
;
; 				:
;	     -   1
;-----------------------------------------------------------------------------------
Func IsInArray(ByRef $arrArray, $strValue)
	Local $i

	If IsArray($arrArray) Then
		For $i = 1 To UBound($arrArray) - 1
			If $arrArray[$i] = $strValue Then
				Return $i
			EndIf
		Next
	Else
		SetError(1)
	EndIf

	Return 0
EndFunc

;-----------------------------------------------------------------------------------
;  ParseText		:      
;
; 				:
; 	strValue			-   
;	$strQuota			-   
;
; 			:
;						-   
;
; 				:
;				~n	- @CRLF
;					~t	- @TAB
;					~q	- "
;					~~	- ~
;-----------------------------------------------------------------------------------
Func ParseText(ByRef $strValue, $strQuota)
	Local $s

	$s = $strValue

	If StringInStr($strQuota, "~n") <> 0 Then
		$s = StringReplace($s, "~n", @CRLF)
	EndIf

	If StringInStr($strQuota, "~t") <> 0 Then
		$s = StringReplace($s, "~t", @TAB)
	EndIf

	If StringInStr($strQuota, "~q") <> 0 Then
		$s = StringReplace($s, "~q", '"')
	EndIf

	If StringInStr($strQuota, "~~") <> 0 Then
		$s = StringReplace($s, "~~", "~")
	EndIf

	$strValue = $s
	Return $s
EndFunc

;-----------------------------------------------------------------------------------
;  ClearTrayTip	:    Tray
;
; 				:
; 						- 
;
; 			:
;						- 
;-----------------------------------------------------------------------------------
Func ClearTrayTip()
	TrayTip("", "", 0)
EndFunc

;-----------------------------------------------------------------------------------
;  	:    Tray
;
; 				:
;	<Title>				-  [1-63 .]
;	<Text>				-   [1-255 .]
;	<Timeout>			-   [1-30 .]
;	<Icon>				- ,   <None|Info|Warning|Error>
;
; 			:
;	Errorlevel 0		-   
;	Errorlevel 1		-   
;-----------------------------------------------------------------------------------
$intEnableBallonTips = RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced", "EnableBalloonTips")

If @error = 0 Then
	If $intEnableBallonTips = 0 Then
		If MsgBox(0x0121, "       System Tray", _
			"          System Tray, " & _
			"     [HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced] " & _
			"  [EnableBalloonTips]   0. " & @CRLF & @CRLF & _
			"     1,        System Tray?", 20) = 1 Then
			
			RegWrite("HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced", "EnableBalloonTips", "REG_DWORD", 1)
			Sleep(500)
			_SendMessage($HWND_BROADCAST, $WM_SETTINGCHANGE, 0, "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced")
			Sleep(500)
		Else
			Exit 2
		EndIf
	EndIf
EndIf

If WinExists("AutoItTrayTip") Then																; ?   
	$PID = WinGetProcess("AutoItTrayTip")														;   ProcessID
	WinSetTitle("AutoItTrayTip", "", "AutoItTrayTip - NeedClear")								;    
	ProcessWaitClose($PID)																		; ,     
EndIf

AutoItWinSetTitle("AutoItTrayTip")																;    AutoIt

If $CmdLine[0] = 4 Then																			; ?    4
	$paramTitle		= $CmdLine[1]																;  1 -  
	$paramText		= $CmdLine[2]																;  2 -  
	$paramTimeout	= $CmdLine[3]																;  3 - 
	$paramIcon		= $CmdLine[4]																;  4 - 

	If Between(StringLen($paramTitle), 1, 63) Then												; ?     63 
		ParseText($paramTitle, "~t~q~~")														;  

		If Between(StringLen($paramText), 1, 255) Then											; ?     255 
			ParseText($paramText, "~t~q~~~n")													;   

			If StringIsDigit($paramTimeout) = 1 Then											; ?   
				$paramTimeout = Number($paramTimeout)											;    

				If Between($paramTimeout, 1, 30) Then											; ?    30
					$intIconFound = Number(IsInArray($arrIconsName, StringUpper($paramIcon)))	;  

					If $intIconFound <> 0 Then													; ?  
						$paramIcon = Number($arrIcons[$intIconFound])							;    
						TrayTip($paramTitle, $paramText, $paramTimeout, $paramIcon)				;    Tray
						
						For $i = 1 to $paramTimeout Step $paramTimeout * 0.01					;      0.01 
							Sleep($paramTimeout * 10)											;   0.01 
							
							If AutoItWinGetTitle() = "AutoItTrayTip - NeedClear" Then			; ?   
								ExitLoop														;   
							EndIf
						Next
						
						;ClearTrayTip()															;  
						AutoItSetOption("TrayIconHide", 1)										;   ,  
						Exit 0																	;     0
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
EndIf

;   -  -    
TrayTip(":", $strUsing1, 5, 1)														;      Tray
Sleep(5000)																						;  5 
ClearTrayTip()																					;  

TrayTip(" :", $strUsing2, 5, 1)											;      Tray
Sleep(5000)																						;  5 
ClearTrayTip()																					;  

Exit 1																							;     1